#include < amxmodx >
#include < as_core >
#include < sqlx >

#define PL_NAME "AS MySQL"
#define PL_VERSION "1.0.0"
#define PL_AUTHOR "OverGame"

#define PL_REFREHS_DB 120.0

new Handle:MYSQL_Tuple;
new Handle:MYSQL_Connect;

new SQL_Active, SQL_Player [ 33 ];
new g_Steam [ 33 ][ 35 ], db_configs [][] = {
	"127.0.0.1", "root", "", "db_name"
}
public plugin_init () {
	register_plugin ( PL_NAME, PL_VERSION, PL_AUTHOR );
	set_task ( PL_REFREHS_DB, "MYSQL_Load", _, _, _, "b" );
	set_task ( 1.0, "MYSQL_Load" );
}
public client_authorized ( id ) get_user_authid ( id, g_Steam [ id ], charsmax ( g_Steam [] ) );
public MYSQL_Load () {
	new szError [ 512 ], szErr;

	MYSQL_Tuple = SQL_MakeDbTuple ( db_configs [ 0 ], db_configs [ 1 ], db_configs [ 2 ], db_configs [ 3 ] );
	MYSQL_Connect= SQL_Connect ( MYSQL_Tuple, szErr, szError, charsmax ( szError ) );

	if ( MYSQL_Connect == Empty_Handle ) set_fail_state ( szError );
	SQL_Active = true;
}
public AS_Save_Base ( id ) {
	new szError [ 512 ];
	new Handle:szUpdate;

	szUpdate = SQL_PrepareQuery ( MYSQL_Connect, "UPDATE `asystem` SET `level` = '%i', `exp` = '%i' WHERE `asystem`.`steam` = '%s';", as_get_user_level ( id ), as_get_user_exp ( id ), g_Steam [ id ] );

	if ( !SQL_Execute ( szUpdate ) ) {
		SQL_QueryError ( szUpdate, szError, charsmax ( szError ) );
		set_fail_state ( szError );
	}
}
public AS_Check_Base ( id ) {
	as_set_user_exp ( id, 0 );
	as_set_user_level ( id, 0 );
	
	if ( !SQL_Active ) {
		set_task ( 1.0, "MYSQL_Load", id );
		return;
	}
	
	new szError [ 512 ];
	new szMYSQLName [ 35 ];
	new Handle:szSelect;

	szSelect = SQL_PrepareQuery ( MYSQL_Connect, "SELECT * FROM asystem" );
	if ( !SQL_Execute ( szSelect ) ) {
		SQL_QueryError ( szSelect, szError, charsmax ( szError ) );
		set_fail_state ( szError );
	}
	while ( SQL_MoreResults ( szSelect ) ) {
		SQL_ReadResult ( szSelect, 1, szMYSQLName, charsmax ( szMYSQLName ) );
	
		if ( equal ( szMYSQLName, g_Steam [ id ] ) ) {
			as_set_user_level ( id, SQL_ReadResult ( szSelect, 3 ) );
			as_set_user_exp ( id, SQL_ReadResult ( szSelect, 4 ) );
			SQL_Player [ id ] = true;
			break;
		} else SQL_NextRow ( szSelect );
	}
	
	new szName [ 33 ]; get_user_name ( id, szName, charsmax ( szName ) );
	if ( !SQL_Player [ id ] ) {
		new Handle:szInsert;
		szInsert = SQL_PrepareQuery ( MYSQL_Connect, "INSERT INTO `asystem` (`steam`, `nick`, `level`, `exp` ) VALUES  ('%s', '%s', '0', '0' );", g_Steam [ id ], szName )

		if ( !SQL_Execute ( szInsert ) ) {
			SQL_QueryError ( szInsert, szError, charsmax ( szError ) );
			set_fail_state ( szError );
		}
		SQL_Player [ id ] = true;
	}
}