#include < amxmodx >
#include < as_core >
#include < nvault >

#define PL_NAME "AS nVault"
#define PL_VERSION "1.0.0"
#define PL_AUTHOR "OverGame"

new g_Vault, g_Steam [ 33 ][ 35 ];
public plugin_init () {
	register_plugin ( PL_NAME, PL_VERSION, PL_AUTHOR );
	
	g_Vault = nvault_open ( "army_system" );
	if ( g_Vault == INVALID_HANDLE ) set_fail_state ( "Error opening nVault!" );
}
public client_authorized ( id ) get_user_authid ( id, g_Steam [ id ], charsmax ( g_Steam [] ) );
public AS_Save_Base ( id ) {
	new s_Get_Buffer [ 40 ], s_Level [ 64 ], s_Exp [ 64 ];
	format ( s_Get_Buffer, charsmax ( s_Get_Buffer ), "%sRANK", g_Steam [ id ] );
	format ( s_Level, charsmax ( s_Level ), "%d", as_get_user_level ( id ) );
	nvault_set ( g_Vault, s_Get_Buffer, s_Level );
	
	format ( s_Get_Buffer, charsmax ( s_Get_Buffer ) , "%sEXP", g_Steam [ id ] );
	format ( s_Exp, charsmax ( s_Exp ), "%d", as_get_user_exp ( id ) );
	nvault_set ( g_Vault, s_Get_Buffer, s_Exp );
}
public AS_Check_Base ( id ) {
	as_set_user_exp ( id, 0 );
	as_set_user_level ( id, 0 );
	
	new s_Get_Buffer [ 40 ];
	formatex ( s_Get_Buffer, charsmax ( s_Get_Buffer ), "%sRANK", g_Steam [ id ] );
	new s_Level = nvault_get ( g_Vault, s_Get_Buffer );
	
	formatex ( s_Get_Buffer, charsmax ( s_Get_Buffer ), "%sEXP", g_Steam [ id ] );
	new s_Exp = nvault_get ( g_Vault, s_Get_Buffer );
	
	if ( s_Level ) {
		as_set_user_level ( id, s_Level );
		as_set_user_exp ( id, s_Exp );
	} else AS_Save_Base ( id );
}